import java.util.Iterator;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.ocl.pivot.Constraint;
import org.eclipse.ocl.pivot.utilities.OCL;

public class ExtendOCL {
	public static void main(String[] args)
	{
		org.eclipse.ocl.pivot.uml.UMLStandaloneSetup.init();
		org.eclipse.ocl.xtext.completeocl.CompleteOCLStandaloneSetup.doSetup();
		org.eclipse.ocl.xtext.oclinecore.OCLinEcoreStandaloneSetup.doSetup();
		org.eclipse.ocl.xtext.oclstdlib.OCLstdlibStandaloneSetup.doSetup();

		ResourceSet resourceSet = new ResourceSetImpl();
		EPackage.Registry registry = resourceSet.getPackageRegistry();
		final URI ecoreFileURI = URI.createURI("MyModel.ecore");
		final URI oclFileURI = URI.createURI("MyModel.ocl");

		final Resource resource = resourceSet.getResource(ecoreFileURI, true);
		final EPackage ePackage = (EPackage) resource.getContents().get(0);
		registry.put(ePackage.getNsURI(), ePackage);

		OCL ocl = OCL.newInstance(registry);
	
		Resource asResource = ocl.parse(oclFileURI);

		for (Iterator<EObject> tit = asResource.getAllContents(); tit.hasNext(); ) {
			EObject next = tit.next();
			if (next instanceof Constraint) {
				final String nextString = next.toString();
				if (nextString.contains("oclBadOperation()")) {
					System.err.println("Constraint:\t" + nextString);
				}
				else {
//					System.out.println("Constraint:\t" + nextString);
				}
			}
		}
	}
}